import { IObservable, Observer } from "jalhyd";
import { FormDefSection } from "../form-def-section";
import { FieldSet } from "../../fieldset";
import { FormulaireBase } from "./form-base";

export class FormulaireRegimeUniforme extends FormulaireBase implements Observer {

    private _formSection: FormDefSection;

    constructor() {
        super();
        this._formSection = new FormDefSection(this);
    }

    protected parseOptions(json: {}) {
        super.parseOptions(json);
        this._formSection.parseOptions(json);
    }

    public afterParseFieldset(fs: FieldSet) {
        this._formSection.afterParseFieldset(fs);
    }

    protected completeParse(json: {}) {
        this._formParamCalc.parseOptions(json);
        super.completeParse(json);
    }

    // interface Observer

    update(sender: IObservable, data: any) {

        super.update(sender, data);

        // changement de propriété du FieldSet contenant le select de choix du type de section
        if (sender instanceof FieldSet && sender.id === "fs_section" && data.action === "propertyChange") {
            this.replaceCurrentNub(sender.properties);
            for (const fs of this.allFieldsets) {
                fs.setNub(this._currentNub);
                // treat the fieldset as new to re-subscribe to Nub properties change events
                this.afterParseFieldset(fs);
            }
            this.reset();
        }
    }
}
