import { Dependency } from "./dependency";
import { FormulaireElement } from "../formulaire-element";
import { ValueDependencyCondition } from "./value-dependency-condition";

/**
 * dépendance déterminant la valeur de l'élément esclave
 */
export class ValueDependency extends Dependency {
    public slaveValue: any;

    constructor(slave: FormulaireElement, masterId: string, masterValue: any) {
        super(slave, masterId, new ValueDependencyCondition(masterValue));
    }

    public toString() {
        return "valdep\n  " + super.toString() + "\n  slave val " + this.slaveValue;
    }
}
